% MUST use -- NIMH_MonkeyLogic_2.2.21  
%     .30 and .34 do NOT work showing 
%           error -- One or more output arguments not assigned during call to "mdqmex". (mglgetproperty, Line 36)
%
% USE left,Up,Down,Right arrows to select cards 1,2,3,4
%

global TotalValue;
global cardCnt
  
fVariableTiming = false;

fDebugShowScenes = false;
fdisplayDashboard = false;
fEditAbleVariables = true;
showSelectionTimeMsec = 250;  %250
showSelectedItemTimeMsec = 850; %850
interStimIntervalMsec = 1100; %1100
showOutcomeMsec = 1500; %100
interTrialIntervalMsec = 150; %500

feedBackFontSize = 40;
InstructionFontSize = 20;
InstructionFontColor =  [0 1 0];

maxIndCard = 2;
maxTrials = 8;
box1Loc = [-10,0];
box2Loc = [-4,0];
box3Loc = [4,0];
box4Loc = [10,0];

if fEditAbleVariables
    editable('showSelectionTimeMsec')
    editable('interStimIntervalMsec')
    editable('showSelectedItemTimeMsec')
    editable('showOutcomeMsec')
    editable('interTrialIntervalMsec')
    editable('fDebugShowScenes')
    editable('fdisplayDashboard')
    editable('fVariableTiming')
    editable('maxIndCard')
    editable('maxTrials')
end

if fVariableTiming
    rng(1);
    isiDelta = randi([-3 3],1,200)*100;
else
    isiDelta = randi([-3 3],1,200)*0;
end

prob = xlsread('Card schedule2.xlsx');
prob(:,1) =[];


adapter_no = 1;
[width,height,refresh_rate] = mglgetadapterdisplaymode(adapter_no);
videoFrameRate = refresh_rate;

if TrialRecord.CurrentTrialWithinBlock < 2 
    fprintf('RefreshRate = %d\n',videoFrameRate);

    cardCnt = [0 0 0 0];
    TotalValue = 2000;
    
end

set_iti(interTrialIntervalMsec);

cueToProbeIdleDelay = 500;  % will check for LATE response during this time
famesPerSecond = videoFrameRate;

maxProbeReactionTimeMsec = 1000;

fcueToProbeDelayScene4_RandomElse600msec = false;

% Which line info is displayed on Observer screen
lineTrialInfo = 1;
lineCueProbeType = 2;
lineCardCnt = 3;
lineCardChosen = 4;
LineCardCnt = 5;
lineCurrState = 6;

ImgFixPoint = 1;
ImgRightBox = 5;
ImgSel1 = 6;
ImgSel2 = 7;
ImgSel3 = 8;
ImgSel4 = 9;
moveUp = 10;
moveLeft = 30;
moveRight = 20;
moveDown = 40;

bhv_code(10,'Fix',20,'Cue',30,'Isi',31,'IsiBegin',32,'IsiEnd',40,'CueToProbeDelay',50,'Probe',55,'Reward',60,'Probe Choice',70,'SlowCue',80,'SlowProbe',90,'Correct',100,'InCorrect',110,'SlowBoth',120,'InitHold');  % behavioral codes

% set hotkey for exit
hotkey('x', 'escape_screen(); assignin(''caller'',''continue_'',false);');

img0a = ImageGraphic(null_);
img0a.List = { ImgFixPoint}; %FixName, cueLocation_db};
tc0a = TimeCounter(img0a);
tc0a.Duration = 1; 
showClearScene = create_scene(tc0a,ImgFixPoint);

kc1L = KeyChecker(mouse_);
kc1L.KeyNum = 1;   % 1st keycode
if cardCnt(kc1L.KeyNum) == maxIndCard
    kc1L.KeyNum = 5;   % 1st keycode
    showImage1 = '1Red.jpg';
else
    showImage1 = '1.jpg';
end
od1L = OnsetDetector(kc1L);

kc1U = KeyChecker(mouse_);
kc1U.KeyNum = 2;   % 2nd keycode
if cardCnt(kc1U.KeyNum) == maxIndCard
    kc1U.KeyNum = 5;   % 1st keycode
    showImage2 = '2Red.jpg';
else
    showImage2 = '2.jpg';
end
od1U = OnsetDetector(kc1U);

kc1D = KeyChecker(mouse_);
kc1D.KeyNum = 3;   % 4th keycode
if cardCnt(kc1D.KeyNum) == maxIndCard
    kc1D.KeyNum = 5;   % 1st keycode
    showImage3 = '3Red.jpg';
else
    showImage3 = '3.jpg';
end
od1D = OnsetDetector(kc1D);

kc1R = KeyChecker(mouse_);
kc1R.KeyNum = 4;   % 3rd keycode
if cardCnt(kc1R.KeyNum) == maxIndCard
    kc1R.KeyNum = 5;   % 1st keycode
    showImage4 = '4Red.jpg';
else
    showImage4 = '4.jpg';
end
od1R = OnsetDetector(kc1R);

img1 = ImageGraphic(null_);
img1.List = {'x.jpg', [0,0]; showImage1, box1Loc; showImage2, box2Loc;showImage3, box3Loc;showImage4, box4Loc;};

tc1 = TimeCounter(img1);
tc1.Duration = showSelectionTimeMsec; 
ora1 = OrAdapter(tc1); 

ora1.add(kc1L);
ora1.add(od1L);

ora1.add(kc1U);
ora1.add(od1U);

ora1.add(kc1R);
ora1.add(od1R);

ora1.add(kc1D);
ora1.add(od1D);

txtSelect = TextGraphic(null_);
txtSelect.Position = [-5 7];
txtSelect.FontSize = feedBackFontSize;
txtSelect.FontColor = [0 1 0];
txtSelect.FontStyle = 'italic'; 
txtSelect.HorizontalAlignment = 'left';
txtSelect.VerticalAlignment = 'middle';
txtSelect.Text = ['Please select a card'];%'+1';
tcSelect = TimeCounter(txtSelect);
tcSelect.Duration = showSelectionTimeMsec; 
ora1.add(tcSelect);

if fDebugShowScenes
    sprintf('-------- ShowTargetsScene1\n'); 
end
showTargets1 = create_scene(ora1); % ImgFixPoint:ImgRightBox);

img2a = ImageGraphic(null_);
img2a.List = { ImgFixPoint}; %FixName, cueLocation_db};
tc2a = TimeCounter(img2a);
tc2a.Duration = interStimIntervalMsec; 
showIsiScene = create_scene(tc2a,ImgFixPoint);

% Setup Se;ectopm Response 
img4 = ImageGraphic(null_);
img4.List = { ImgFixPoint}; %FixName, cueLocation_db};
probe_tc4 = TimeCounter(img4);
probe_tc4.Duration = showSelectedItemTimeMsec; %500;

showResponseLeft = create_scene(probe_tc4,[ImgFixPoint:ImgRightBox,ImgSel1]); %,ImgFixPoint);
showResponseUp = create_scene(probe_tc4,[ImgFixPoint:ImgRightBox,ImgSel2]); %,ImgFixPoint);
showResponseRight = create_scene(probe_tc4,[ImgFixPoint:ImgRightBox,ImgSel3]); %,ImgFixPoint);
showResponseDown = create_scene(probe_tc4,[ImgFixPoint:ImgRightBox,ImgSel4]); %,ImgFixPoint);

imgResult = ImageGraphic(null_);
imgResult.List = {'x.jpg', [0,0]; showImage1, box1Loc; showImage2, box2Loc;showImage3, box3Loc;showImage4, box4Loc;};
tcResult = TimeCounter(imgResult);
tcResult.Duration = showOutcomeMsec;
orResult = AndAdapter(tcResult);

txtPos = TextGraphic(null_);
txtPos.Position = [-9 0];
txtPos.FontSize = feedBackFontSize;
txtPos.FontColor = [0 1 0];
txtPos.FontStyle = 'italic'; 
txtPos.HorizontalAlignment = 'center';
txtPos.VerticalAlignment = 'middle';
txtPos.Text = ['+'  num2str(300)];%'+1';
tcCorrectResponse = TimeCounter(txtPos);
tcCorrectResponse.Duration = showOutcomeMsec; %maxTimeToShowResultToSubject; %NA_ProbeTimeMsec; %responseDurationMsec;
%orTxt = OrAdapter(tcCorrectResponse);
gp1 = GraphicProperty(null_);
gp1.Target = txtPos;
gp1.Property = 'Zorder';
gp1.Value = 1;
%gp1.Duration = showOutcomeMsec;
orResult.add(gp1);

txtNeg = TextGraphic(null_);
txtNeg.Position = [-9 -2];
txtNeg.FontSize = feedBackFontSize;
txtNeg.FontColor = [1 0 0];
txtNeg.FontStyle = 'italic';
txtNeg.HorizontalAlignment = 'center';
txtNeg.VerticalAlignment = 'middle';
txtNeg.Text = ['-' num2str(400)];% '+0';
tcNegResponse = TimeCounter(txtNeg);
tcNegResponse.Duration = showOutcomeMsec;
gp2 = GraphicProperty(null_);
gp2.Target = txtNeg;
gp2.Property = 'Zorder';
gp2.Value = 1;
orResult.add(gp2);

txtTotal = TextGraphic(null_);
txtTotal.Position = [-11 -6];
txtTotal.FontSize = feedBackFontSize;
txtTotal.FontColor = [1 0 0];
txtTotal.FontStyle = 'italic';
txtTotal.HorizontalAlignment = 'left';
txtTotal.VerticalAlignment = 'middle';
txtTotal.Text = ['-' num2str(400)];% '+0';
tcTotalResponse = TimeCounter(txtTotal);
tcTotalResponse.Duration = showOutcomeMsec;
orResult.add(tcTotalResponse);

sceneCorrectResponse = create_scene(orResult); %tcCorrectResponse);

txtDone = TextGraphic(null_);
txtDone.Position = [-11 -6];
txtDone.FontSize = feedBackFontSize*2;
txtDone.FontColor = [1 0 0];
txtDone.FontStyle = 'italic';
txtDone.HorizontalAlignment = 'left';
txtDone.VerticalAlignment = 'middle';
txtDone.Text = 'Remain Still!';% '+0';
tcDone = TimeCounter(txtDone);
tcDone.Duration = 10; %Remains on screen so minimal time needed

sceneDone = create_scene(tcDone); %tcCorrectResponse);


% -------------------  Run Task ------------------------------------

ArrowMove = 0;
if fdisplayDashboard
    dashboard(lineCurrState,sprintf(''));
    dashboard(lineCardChosen,sprintf(''));
    dashboard(lineCardChosen,sprintf(''));
end

if fDebugShowScenes
    fprintf('showTargets1\n'); 
end

selCard = 0;
cardDisplay = trialtime;

run_scene(showTargets1,20);     % Run the Cue scene (eventmarker 20, Cue Gabor)

    if kc1L.Success && cardCnt(1) < maxIndCard
        if fdisplayDashboard
            dashboard(lineCardChosen,sprintf('1'));
        end
        rtCue = kc1L.Time(1);
       cueResonseEarlyFailed = 0;
       ArrowMove = moveLeft;
       selCard = 1;
       cardCnt(selCard) = cardCnt(selCard) + 1;
  
    elseif kc1U.Success && cardCnt(2) < maxIndCard
        if fdisplayDashboard
            dashboard(lineCardChosen,sprintf('2'));
        end
        rtCue = kc1U.Time(1);
         cueResonseEarlyFailed = 0;
        ArrowMove = moveUp;
        selCard = 2;
        cardCnt(selCard) = cardCnt(selCard) + 1;
        
    elseif kc1R.Success && cardCnt(3) < maxIndCard
        if fdisplayDashboard
            dashboard(lineCardChosen,sprintf('3'));
        end
        rtCue = kc1R.Time(1);
        cueResonseEarlyFailed = 0;
        ArrowMove = moveRight;
        selCard = 3;
        cardCnt(selCard) = cardCnt(selCard) + 1;
      
    elseif kc1D.Success && cardCnt(4) < maxIndCard
        if fdisplayDashboard
            dashboard(lineCardChosen,sprintf('4'));
        end
       rtCue = kc1D.Time(1);
       cueResonseEarlyFailed = 0;
       ArrowMove = moveDown;
       selCard = 4;
       cardCnt(selCard) = cardCnt(selCard) + 1;   
    else
        selCard = 0;  % needs fix !  13Dec21
        fNoSelection = true;
        if fdisplayDashboard
            dashboard(lineCardChosen,sprintf('NO Choice'));
        end
        cueResonseEarlyFailed = 1;
    end
    
    if selCard > 0 %&& any(cardCnt)
       TotalValue = TotalValue + prob(cardCnt((selCard)), ((selCard-1)*2)+ 1);
       TotalValue = TotalValue + prob(cardCnt((selCard)), ((selCard-1)*2)+ 2);
    end
    
    if cueResonseEarlyFailed ==1 
        rtCue = trialtime;
    end
        
    rt = rtCue - cardDisplay;

    if fDebugShowScenes
        fprintf('showISIscene\n'); 
    end

    TrialRecord.User.showProbeScene3Begin = trialtime;
    bhv_variable('showProbeScene3',trialtime);

isiBegin = trialtime;
tc0.Duration = interStimIntervalMsec + isiDelta(TrialRecord.CurrentTrialWithinBlock);

run_scene(showIsiScene,30);

    if fdisplayDashboard
        dashboard(lineCardCnt,sprintf('isiDelta = %5.2f',trialtime - isiBegin));
    end 
 
if ArrowMove == moveLeft
    txtPos.Position = [-10.5 0];
    txtNeg.Position = [-10.5 -2];
elseif ArrowMove == moveUp
    txtPos.Position = [-4.5 0];
    txtNeg.Position = [-4.5 -2];
elseif ArrowMove == moveRight
    txtPos.Position = [4 0];
    txtNeg.Position = [4 -2];
elseif ArrowMove == moveDown
    txtPos.Position = [10 0];
    txtNeg.Position = [10 -2];
end

  dashboard(lineCardCnt,sprintf('Selected %d cardCnt (%d  %d  %d  %d )',selCard, cardCnt));
   
if selCard > 0 
    dashboard(LineCardCnt,sprintf(num2str(prob(cardCnt(selCard),((selCard-1)*2)+ 1)))); %cardCnt(selCard),(selCard-1)*2)+ 1)));   
 
    txtPos.Text = ['+ ' sprintf(num2str(prob(cardCnt(selCard),((selCard-1)*2)+ 1)))];

    txtNeg.Text = sprintf(num2str(prob(cardCnt(selCard),((selCard-1)*2)+ 2)));

    if TotalValue > 0
        txtTotal.FontColor = [0 1 0];
        txtTotal.Text = [sprintf( 'Current Balance = + %d ',TotalValue)];
    else
        txtTotal.FontColor = [1 0 0];
        txtTotal.Text = [sprintf( 'Current Balance = %d ',TotalValue)];
    end
    
else
    txtTotal.FontColor = [1 0 0];
    
    txtTotal.Text = sprintf('No Response ');
    
    txtPos.Text = sprintf('               ');
    txtNeg.Text = sprintf('               ');
end


run_scene(sceneCorrectResponse,90);

    if fDebugShowScenes
        fprintf('showIti\n'); 
    end

    if fdisplayDashboard
        dashboard(lineCurrState,sprintf('ITI'));
    end
    
run_scene(showClearScene);

if TrialRecord.CurrentTrialWithinBlock == maxTrials
    run_scene(sceneDone);
end

set_iti(interTrialIntervalMsec);

